'******************************************************************************
'*  yaz80_demo.spin - demo mode for the yaz80 core
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: yaz80_demo.spin,v 1.21 2010-03-31 05:33:17 pm Exp $
'******************************************************************************
CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
'	_xinfreq		= 6_500_000		' Quartz is 6.5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz/96MHz

' Select your poison
#define CPU_Z80
'#define CPU_8080

'' Define if you want to run this on the TriBladeProp #2,
'' on the RamBladeProp or on the DracBladeProp
'#define TriBladeProp
'#define RamBladeProp
#define DracBladeProp

' Select your video norm
'#define NTSC
#define PAL

' Uncomment to have debug code inserted
'#define DEBUG

' Uncomment to emulate interrupts (NMI and IRQ)
'#define INTERRUPTS

' Uncomment to emulate undocumented X and Y flags (partially)
'#define XYFLAGS

' Uncomment to count cycles
'#define COUNT_C

' Uncomment to count R register
#define COUNT_R

#define	SD
#ifdef TriBladeProp
' serial I/O pins on the TriBladeProp #2
	SI			= 31
	SO			= 30
	SI2			= -1
	SO2			= -1
' Keyboard pins
#define HAVE_KBD
	kbDpin			= 26
	kbCpin			= 27
' SD pins on the TriBladeProp #2
#define HAVE_SD
	doPin			= 9
	clkPin			= 28
	diPin			= 8
	csPin			= 14
' VGA pins on the TriBladeProp #2 - none?
#undef  HAVE_VGA
	vgaPin			= 16
#endif TriBladeProp

#ifdef RamBladeProp
' serial I/O pins on the RamBladeProp (secondary?)
	SI			= 23
	SO			= 22
	SI2			= -1
	SO2			= -1
' Keyboard pins
#undef HAVE_KBD
	kbDpin			= -1
	kbCpin			= -1
' microSD pins on RamBladeProp
#define HAVE_SD
	doPin			= 24
	clkPin			= 26
	diPin			= 25
	csPin			= 19
' VGA pins on the RamBladeProp - none?
	vgaPin			= -1
#undef  HAVE_VGA
#endif RamBladeProp

#ifdef DracBladeProp
' serial I/O pins on the DracBladeProp
	SI			= 31
	SO			= 30
	SI2			= 25
	SO2			= 24
' Keyboard pins
#define HAVE_KBD
	kbDpin			= 26
	kbCpin			= 27
' SD pins on the DracBladeProp
#define HAVE_SD
	doPin			= 12
	clkPin			= 13
	diPin			= 14
	csPin			= 15
' VGA pins on the DracBladeProp - 16-23
#undef HAVE_VGA
	vgaPin			= 16
#endif DracBladeProp


VAR
#ifdef COUNT_C
	long	cycles
	long	time
#endif COUNT_C

OBJ
        yaz80	: "yaz80"
	io	: "io"

PUB     main : okay

        okay := io.start(SI, SO, SI2, SO2, doPin, clkPin, diPin, csPin, kbDpin, kbCpin, vgaPin)

#ifdef COUNT_C
	okay := \yaz80.start(io.command_addr, 0, @cycles)
#else  COUNT_C
	okay := \yaz80.start(io.command_addr, 0, 0)
#endif !COUNT_C
	if okay < 0
		io.str(string("yaz80 failed: "))
		io.dec(okay)
		io.crlf
		return
	repeat
#ifdef COUNT_C
		io.dec(800_000_000/time*cycles/10)
		io.crlf
		waitcnt(CNT + clkfreq/2)
#endif

DAT
#ifdef PropRPM
memory
		file	"page0.bin"

#ifdef	EXZ80DOC
		file	"EXZ80DOC.COM"
#else
		file	"demo.bin"
#endif
#endif
